import UIKit
import Flutter
import BankConnect
import SwiftUI

public class FinBoxViewController: UIViewController {
    
    public override func viewDidLoad() {
        debugPrint("View Controller Loaded")
        
        // BankConnect Swift UI element
        let swiftUIView = BankView() {
            payload in
            // Send the data back to the flutter plugin
            self.bankResultCallback(data: payload)
            // Close the view
            self.dismiss(animated: true)
        }
        
        // Handles the Swift UI elements on UI Kit
        let child = UIHostingController(rootView: swiftUIView)
        // Set the bounds
        child.view.frame = view.bounds
        
        // Add the child to the view
        self.view.addSubview(child.view)
    }
    
    func bankResultCallback(data: FinBoxPayload) {
        let encoder = JSONEncoder()
        do {
            let result = try encoder.encode(data)
            let jsonResult = String(data: result, encoding: .utf8)
            // Send the callback to flutter
            FinBoxBcPlugin.channel?.invokeMethod("getJourneyResult", arguments: jsonResult)
        } catch let error {
            debugPrint("JSON decode error", error.localizedDescription)
        }
    }
    
}
